## qxmpp 1.13.0

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2017 Niels Ole Salscheider <niels_ole@salscheider-online.de>
#
# SPDX-License-Identifier: CC0-1.0

cmake_minimum_required(VERSION 3.16)
project(qxmpp VERSION 1.13.0)

set(SO_VERSION 7)

# C++ standard settings:
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

find_package(PkgConfig REQUIRED)

# Qt
if(BUILD_WITH_QT6)
    set(QT_VERSION_MAJOR 6)
endif()
if(NOT DEFINED QT_VERSION_MAJOR)
    find_package(QT NAMES Qt6 Qt5 REQUIRED COMPONENTS Core Network Xml)
endif()
message("-- Choosing Qt ${QT_VERSION_MAJOR}")
find_package(Qt${QT_VERSION_MAJOR} 5.15.0 REQUIRED COMPONENTS Core Network Xml)

# QCA (optional)
find_package(Qca-qt${QT_VERSION_MAJOR} QUIET)
if(${QT_VERSION_MAJOR} EQUAL 6)
    find_package(Qt6Core5Compat)
endif()

include(GNUInstallDirs)

option(BUILD_WITH_QT6 "Force build with Qt 6")
option(BUILD_SHARED "Build shared library" ON)
option(BUILD_TESTS "Build tests." ON)
option(BUILD_INTERNAL_TESTS "Build internal tests." OFF)
option(BUILD_DOCUMENTATION "Build API documentation." OFF)
option(BUILD_EXAMPLES "Build examples." ON)
option(BUILD_OMEMO "Build the OMEMO module" OFF)
option(WITH_GSTREAMER "Build with GStreamer support for Jingle" OFF)
option(WITH_QCA "Build with QCA for OMEMO or encrypted file sharing" ${Qca-qt${QT_VERSION_MAJOR}_FOUND})
option(ENABLE_ASAN "Build with address sanitizer" OFF)

set(QXMPP_TARGET QXmppQt${QT_VERSION_MAJOR})
set(QXMPPOMEMO_TARGET QXmppOmemoQt${QT_VERSION_MAJOR})

add_definitions(
    -DQT_DISABLE_DEPRECATED_BEFORE=0x060900
    -DQT_NO_URL_CAST_FROM_STRING
    -DQT_NO_CAST_TO_ASCII
    -DQT_NO_CAST_FROM_BYTEARRAY
    -DQT_USE_QSTRINGBUILDER
    -DQT_NO_FOREACH
    -DQT_NO_KEYWORDS
)

# Address sanitizer
if(ENABLE_ASAN)
    add_compile_options(-fsanitize=address)
    add_link_options(-fsanitize=address)
endif()

if(BUILD_OMEMO)
    add_definitions(-DBUILD_OMEMO)

    # libomemo-c
    pkg_check_modules(OmemoC REQUIRED IMPORTED_TARGET libomemo-c)

    # QCA
    if(NOT WITH_QCA)
        message(FATAL_ERROR "OMEMO requires QCA (Qt Cryptographic Architecture)")
    endif()
endif()

if(WITH_QCA)
    add_definitions(-DWITH_QCA)
endif()

if(WITH_GSTREAMER)
    pkg_check_modules(GStreamer REQUIRED IMPORTED_TARGET gstreamer-1.0>=1.20)
    pkg_check_modules(GStreamerBase REQUIRED IMPORTED_TARGET gstreamer-base-1.0)
endif()

add_subdirectory(src)

if(BUILD_TESTS)
    enable_testing()
    add_subdirectory(tests)
endif()

if(BUILD_DOCUMENTATION)
    add_subdirectory(doc)
endif()

if(BUILD_EXAMPLES)
    add_subdirectory(examples)
endif()

include(CMakePackageConfigHelpers)

# Normal QXmppQt5/6 package
configure_package_config_file(
    QXmppConfig.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/${QXMPP_TARGET}Config.cmake
    INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${QXMPP_TARGET}"
)

write_basic_package_version_file(
    ${CMAKE_CURRENT_BINARY_DIR}/${QXMPP_TARGET}ConfigVersion.cmake
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY SameMajorVersion
)

install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/${QXMPP_TARGET}Config.cmake
          ${CMAKE_CURRENT_BINARY_DIR}/${QXMPP_TARGET}ConfigVersion.cmake
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${QXMPP_TARGET}"
    COMPONENT Devel
)

# Generate QXmppQt5/6.pc
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/qxmpp.pc.in ${CMAKE_CURRENT_BINARY_DIR}/${QXMPP_TARGET}.pc @ONLY)
install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/${QXMPP_TARGET}.pc
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
    COMPONENT Devel
)

if(QT_VERSION_MAJOR EQUAL 5)
    # "QXmpp" cmake package for backwards-compatibility
    configure_package_config_file(
        cmake/QXmppLegacyConfig.cmake.in
        ${CMAKE_CURRENT_BINARY_DIR}/QXmppConfig.cmake
        INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/QXmpp"
    )

    install(
        FILES ${CMAKE_CURRENT_BINARY_DIR}/QXmppConfig.cmake
        DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/QXmpp"
        COMPONENT Devel
    )
    install(
        FILES ${CMAKE_CURRENT_SOURCE_DIR}/cmake/QXmppLegacyConfigVersion.cmake
        RENAME QXmppConfigVersion.cmake
        DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/QXmpp"
        COMPONENT Devel
    )

    # "qxmpp.pc" for backwards-compatibility
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/qxmpp_legacy.pc.in ${CMAKE_CURRENT_BINARY_DIR}/qxmpp.pc @ONLY)
    install(
        FILES ${CMAKE_CURRENT_BINARY_DIR}/qxmpp.pc
        DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
        COMPONENT Devel
    )
endif()

=== src/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2017 Niels Ole Salscheider <niels_ole@salscheider-online.de>
#
# SPDX-License-Identifier: CC0-1.0

include(GenerateExportHeader)

# extra definitions, only for src/
add_definitions(
    -DQT_NO_CAST_FROM_ASCII
)

set(INSTALL_HEADER_FILES
    # Base
    base/QXmppArchiveIq.h
    base/QXmppBindIq.h
    base/QXmppBitsOfBinaryContentId.h
    base/QXmppBitsOfBinaryData.h
    base/QXmppBitsOfBinaryDataList.h
    base/QXmppBitsOfBinaryIq.h
    base/QXmppBookmarkSet.h
    base/QXmppByteStreamIq.h
    base/QXmppColorGeneration.h
    base/QXmppConstants_p.h
    base/QXmppContactAddresses.h
    base/QXmppDataForm.h
    base/QXmppDataFormBase.h
    base/QXmppDiscoveryIq.h
    base/QXmppE2eeMetadata.h
    base/QXmppEncryptedFileSource.h
    base/QXmppElement.h
    base/QXmppEntityTimeIq.h
    base/QXmppError.h
    base/QXmppExtension.h
    base/QXmppExternalService.h
    base/QXmppExternalServiceDiscoveryIq.h
    base/QXmppFallback.h
    base/QXmppFileMetadata.h
    base/QXmppFileShare.h
    base/QXmppAsync_p.h
    base/QXmppGeolocItem.h
    base/QXmppGlobal.h
    base/QXmppHash.h
    base/QXmppHttpFileSource.h
    base/QXmppHttpUploadIq.h
    base/QXmppIbbIq.h
    base/QXmppIq.h
    base/QXmppJingleIq.h
    base/QXmppJingleData.h
    base/QXmppLogger.h
    base/QXmppMamIq.h
    base/QXmppMessage.h
    base/QXmppMessageReaction.h
    base/QXmppMixConfigItem.h
    base/QXmppMixInfoItem.h
    base/QXmppMixInvitation.h
    base/QXmppMixIq.h
    base/QXmppMixIq_p.h
    base/QXmppMixParticipantItem.h
    base/QXmppMucIq.h
    base/QXmppMucForms.h
    base/QXmppNonza.h
    base/QXmppNonSASLAuth.h
    base/QXmppOutOfBandUrl.h
    base/QXmppPingIq.h
    base/QXmppPresence.h
    base/QXmppPromise.h
    base/QXmppPubSubAffiliation.h
    base/QXmppPubSubEvent.h
    base/QXmppPubSubIq_p.h
    base/QXmppPubSubBaseItem.h
    base/QXmppPubSubMetadata.h
    base/QXmppPubSubNodeConfig.h
    base/QXmppPubSubPublishOptions.h
    base/QXmppPubSubSubscribeOptions.cpp
    base/QXmppPubSubSubscription.h
    base/QXmppPubSubSubAuthorization.h
    base/QXmppPushEnableIq.h
    base/QXmppRegisterIq.h
    base/QXmppResultSet.h
    base/QXmppRosterIq.h
    base/QXmppRpcIq.h
    base/QXmppSasl2UserAgent.h
    base/QXmppSendResult.h
    base/QXmppSocks.h
    base/QXmppStanza.h
    base/QXmppStreamError.h
    base/QXmppStreamFeatures.h
    base/QXmppStun.h
    base/QXmppTask.h
    base/QXmppThumbnail.h
    base/QXmppTrustMessageElement.h
    base/QXmppTrustMessageKeyOwner.h
    base/QXmppTrustMessages.h
    base/QXmppUserTuneItem.h
    base/QXmppUtils.h
    base/QXmppUtils_p.h
    base/QXmppUri.h
    base/QXmppVCardIq.h
    base/QXmppVersionIq.h
    base/QXmppVisitHelper_p.h
    base/QXmppXmlTags_p.h
    base/compat/QXmppSessionIq.h
    base/compat/QXmppStartTlsPacket.h
    base/compat/QXmppPubSubIq.h
    base/compat/QXmppPubSubItem.h

    # Client
    client/QXmppAccountMigrationManager.h
    client/QXmppArchiveManager.h
    client/QXmppAtmManager.h
    client/QXmppAtmTrustMemoryStorage.h
    client/QXmppAtmTrustStorage.h
    client/QXmppAttentionManager.h
    client/QXmppAuthenticationError.h
    client/QXmppBindError.h
    client/QXmppBlockingManager.h
    client/QXmppBookmarkManager.h
    client/QXmppCallInviteManager.h
    client/QXmppCarbonManager.h
    client/QXmppCarbonManagerV2.h
    client/QXmppClient.h
    client/QXmppClientExtension.h
    client/QXmppConfiguration.h
    client/QXmppCredentials.h
    client/QXmppDiscoveryManager.h
    client/QXmppE2eeExtension.h
    client/QXmppEntityTimeManager.h
    client/QXmppExternalServiceDiscoveryManager.h
    client/QXmppFileSharingManager.h
    client/QXmppFileSharingProvider.h
    client/QXmppHttpFileSharingProvider.h
    client/QXmppHttpUploadManager.h
    client/QXmppInvokable.h
    client/QXmppIqHandling.h
    client/QXmppJingleMessageInitiationManager.h
    client/QXmppMamManager.h
    client/QXmppMessageHandler.h
    client/QXmppMessageReceiptManager.h
    client/QXmppMixManager.h
    client/QXmppMovedManager.h
    client/QXmppMucManager.h
    client/QXmppMucManagerV2.h
    client/QXmppOutgoingClient.h
    client/QXmppRegistrationManager.h
    client/QXmppPubSubEventHandler.h
    client/QXmppPubSubManager.h
    client/QXmppRemoteMethod.h
    client/QXmppRosterManager.h
    client/QXmppRpcManager.h
    client/QXmppSendStanzaParams.h
    client/QXmppTransferManager.h
    client/QXmppTransferManager_p.h
    client/QXmppTrustLevel.h
    client/QXmppTrustManager.h
    client/QXmppTrustMemoryStorage.h
    client/QXmppTrustSecurityPolicy.h
    client/QXmppTrustStorage.h
    client/QXmppUploadRequestManager.h
    client/QXmppUserTuneManager.h
    client/QXmppUserLocationManager.h
    client/QXmppVCardManager.h
    client/QXmppVersionManager.h

    # Server
    server/QXmppDialback.h
    server/QXmppIncomingClient.h
    server/QXmppIncomingServer.h
    server/QXmppOutgoingServer.h
    server/QXmppPasswordChecker.h
    server/QXmppServer.h
    server/QXmppServerExtension.h
    server/QXmppServerPlugin.h
)

set(SOURCE_FILES
    # Base
    base/Stream.cpp
    base/QXmppArchiveIq.cpp
    base/QXmppBitsOfBinary.cpp
    base/QXmppBookmarkSet.cpp
    base/QXmppByteStreamIq.cpp
    base/QXmppColorGeneration.cpp
    base/QXmppContactAddresses.cpp
    base/QXmppDataForm.cpp
    base/QXmppDataFormBase.cpp
    base/QXmppDiscoveryIq.cpp
    base/QXmppElement.cpp
    base/QXmppEncryptedFileSource.cpp
    base/QXmppEntityTimeIq.cpp
    base/QXmppError.cpp
    base/QXmppExternalServiceDiscoveryIq.cpp
    base/QXmppFileMetadata.cpp
    base/QXmppFileShare.cpp
    base/QXmppGeolocItem.cpp
    base/QXmppHash.cpp
    base/QXmppHashing.cpp
    base/QXmppHttpFileSource.cpp
    base/QXmppHttpUploadIq.cpp
    base/QXmppIbbIq.cpp
    base/QXmppIq.cpp
    base/QXmppJingleData.cpp
    base/QXmppLogger.cpp
    base/QXmppMamIq.cpp
    base/QXmppMessage.cpp
    base/QXmppMessageReaction.cpp
    base/QXmppMixInvitation.cpp
    base/QXmppMixIq.cpp
    base/QXmppMixItems.cpp
    base/QXmppMucIq.cpp
    base/QXmppMucForms.cpp
    base/QXmppNonza.cpp
    base/QXmppNonSASLAuth.cpp
    base/QXmppOutOfBandUrl.cpp
    base/QXmppPacket.cpp
    base/QXmppPingIq.cpp
    base/QXmppPresence.cpp
    base/QXmppPubSubAffiliation.cpp
    base/QXmppPubSubEvent.cpp
    base/QXmppPubSubIq.cpp
    base/QXmppPubSubBaseItem.cpp
    base/QXmppPubSubMetadata.cpp
    base/QXmppPubSubNodeConfig.cpp
    base/QXmppPubSubSubscribeOptions.cpp
    base/QXmppPubSubSubscription.cpp
    base/QXmppPubSubSubAuthorization.cpp
    base/QXmppPushEnableIq.cpp
    base/QXmppRegisterIq.cpp
    base/QXmppResultSet.cpp
    base/QXmppRosterIq.cpp
    base/QXmppRpcIq.cpp
    base/QXmppSasl.cpp
    base/QXmppSocks.cpp
    base/QXmppStanza.cpp
    base/QXmppStreamFeatures.cpp
    base/QXmppStreamInitiationIq.cpp
    base/QXmppStreamManagement.cpp
    base/QXmppStun.cpp
    base/QXmppThumbnail.cpp
    base/QXmppTrustMessages.cpp
    base/QXmppUri.cpp
    base/QXmppUserTuneItem.cpp
    base/QXmppUtils.cpp
    base/QXmppVCardIq.cpp
    base/QXmppVersionIq.cpp
    base/compat/removed_api.cpp
    base/hsluv/hsluv.c
    base/XmlWriter.cpp
    # to trigger MOC
    base/XmppSocket.h

    # Client
    client/QXmppAccountMigrationManager.cpp
    client/QXmppArchiveManager.cpp
    client/QXmppAtmManager.cpp
    client/QXmppAtmTrustMemoryStorage.cpp
    client/QXmppAtmTrustStorage.cpp
    client/QXmppAttentionManager.cpp
    client/QXmppBlockingManager.cpp
    client/QXmppBookmarkManager.cpp
    client/QXmppCallInviteManager.cpp
    client/QXmppCarbonManager.cpp
    client/QXmppCarbonManagerV2.cpp
    client/QXmppClient.cpp
    client/QXmppClientExtension.cpp
    client/QXmppConfiguration.cpp
    client/QXmppDiscoveryManager.cpp
    client/QXmppE2eeExtension.cpp
    client/QXmppEntityTimeManager.cpp
    client/QXmppExternalServiceDiscoveryManager.cpp
    client/QXmppFileSharingManager.cpp
    client/QXmppHttpFileSharingProvider.cpp
    client/QXmppHttpUploadManager.cpp
    client/QXmppInvokable.cpp
    client/QXmppIqHandling.cpp
    client/QXmppJingleMessageInitiationManager.cpp
    client/QXmppMamManager.cpp
    client/QXmppMessageReceiptManager.cpp
    client/QXmppMixManager.cpp
    client/QXmppMovedManager.cpp
    client/QXmppMucManager.cpp
    client/QXmppMucManagerV2.cpp
    client/QXmppOutgoingClient.cpp
    client/QXmppRosterManager.cpp
    client/QXmppRegistrationManager.cpp
    client/QXmppPubSubManager.cpp
    client/QXmppSaslManager.cpp
    client/QXmppSendStanzaParams.cpp
    client/QXmppTransferManager.cpp
    client/QXmppTrustManager.cpp
    client/QXmppTrustMemoryStorage.cpp
    client/QXmppTrustStorage.cpp
    client/QXmppUploadRequestManager.cpp
    client/QXmppUserLocationManager.cpp
    client/QXmppUserTuneManager.cpp
    client/QXmppVCardManager.cpp
    client/QXmppVersionManager.cpp
    client/compat/removed_api.cpp

    # Server
    server/QXmppDialback.cpp
    server/QXmppIncomingClient.cpp
    server/QXmppIncomingServer.cpp
    server/QXmppOutgoingServer.cpp
    server/QXmppPasswordChecker.cpp
    server/QXmppServer.cpp
    server/QXmppServerExtension.cpp
    server/QXmppServerPlugin.cpp
)

if(BUILD_SHARED)
    add_library(${QXMPP_TARGET} SHARED ${SOURCE_FILES})
else()
    add_library(${QXMPP_TARGET} STATIC ${SOURCE_FILES})
endif()

set_target_properties(${QXMPP_TARGET} PROPERTIES
    VERSION ${PROJECT_VERSION}
    SOVERSION ${SO_VERSION}
    EXPORT_NAME QXmpp
)

target_include_directories(${QXMPP_TARGET}
    PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/base>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/client>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/server>
    $<INSTALL_INTERFACE:include/${QXMPP_TARGET}>
    PRIVATE
    ${CMAKE_CURRENT_BINARY_DIR}
)

target_link_libraries(${QXMPP_TARGET}
    PUBLIC
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Network
    Qt${QT_VERSION_MAJOR}::Xml
)

if(WITH_GSTREAMER)
    set(INSTALL_HEADER_FILES
        ${INSTALL_HEADER_FILES}
        client/QXmppCall.h
        client/QXmppCallManager.h
        client/QXmppCallStream.h
    )

    target_sources(${QXMPP_TARGET}
        PRIVATE
        client/GstWrapper.cpp
        client/QXmppCall.cpp
        client/QXmppCallManager.cpp
        client/QXmppCallStream.cpp
    )

    target_link_libraries(${QXMPP_TARGET}
        PRIVATE
        PkgConfig::GStreamer
        PkgConfig::GStreamerBase
    )
endif()

if(BUILD_OMEMO)
    # required to be used in QXmppMessage
    target_sources(${QXMPP_TARGET} PRIVATE base/QXmppOmemoDataBase.cpp)
endif()

if(WITH_QCA)
    target_sources(${QXMPP_TARGET} PRIVATE client/QXmppEncryptedFileSharingProvider.cpp client/QXmppFileEncryption.cpp client/QcaInitializer.cpp)
    set(INSTALL_HEADER_FILES ${INSTALL_HEADER_FILES} client/QXmppEncryptedFileSharingProvider.h)
    target_link_libraries(${QXMPP_TARGET} PRIVATE qca-qt${QT_VERSION_MAJOR})
endif()

# qxmpp_export.h generation
if(BUILD_SHARED)
    set(QXMPP_BUILD_SHARED true)
else()
    set(QXMPP_BUILD_SHARED false)
endif()

set(QXMPP_CUSTOM_EXPORT_CONTENT "
#define QXMPP_BUILD_SHARED ${QXMPP_BUILD_SHARED}
#define QXMPP_VERSION_MAJOR ${PROJECT_VERSION_MAJOR}
#define QXMPP_VERSION_MINOR ${PROJECT_VERSION_MINOR}
#define QXMPP_VERSION_PATCH ${PROJECT_VERSION_PATCH}
")

generate_export_header(${QXMPP_TARGET}
    BASE_NAME qxmpp
    CUSTOM_CONTENT_FROM_VARIABLE QXMPP_CUSTOM_EXPORT_CONTENT
)

install(
    TARGETS ${QXMPP_TARGET}
    EXPORT QXmppTarget
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(
    EXPORT QXmppTarget
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${QXMPP_TARGET}"
    FILE QXmpp.cmake
    NAMESPACE QXmpp::
    COMPONENT Devel
)

export(
    TARGETS ${QXMPP_TARGET}
    FILE QXmpp.cmake
)

install(
    FILES ${INSTALL_HEADER_FILES} ${CMAKE_CURRENT_BINARY_DIR}/qxmpp_export.h
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/${QXMPP_TARGET}"
)

# submodules
if(BUILD_OMEMO)
    add_subdirectory(omemo)

=== tests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2017 Niels Ole Salscheider <niels_ole@salscheider-online.de>
#
# SPDX-License-Identifier: CC0-1.0

include_directories(.)

find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Test)

# optional QtGui support (for testing header-only usage)
find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Gui QUIET)

macro(add_simple_test TEST_NAME)
    add_executable(tst_${TEST_NAME} ${TEST_NAME}/tst_${TEST_NAME}.cpp ${ARGN})
    add_test(tst_${TEST_NAME} tst_${TEST_NAME})
    target_link_libraries(tst_${TEST_NAME} Qt${QT_VERSION_MAJOR}::Test ${QXMPP_TARGET})
    if(${TEST_NAME} MATCHES "^qxmppomemo")
        target_link_libraries(tst_${TEST_NAME} ${QXMPPOMEMO_TARGET})
    endif()
endmacro()

include_directories(${PROJECT_SOURCE_DIR}/src/base)
include_directories(${PROJECT_SOURCE_DIR}/src/client)
include_directories(${PROJECT_SOURCE_DIR}/src/omemo)
include_directories(${PROJECT_SOURCE_DIR}/src/server)
include_directories(${PROJECT_BINARY_DIR}/src)
include_directories(${PROJECT_BINARY_DIR}/src/omemo)
include_directories(${CMAKE_CURRENT_BINARY_DIR})
if(BUILD_INTERNAL_TESTS)
    add_definitions(-DBUILD_INTERNAL_TESTS)
endif()

add_simple_test(qxmppaccountmigrationmanager TestClient.h)
add_simple_test(qxmppattentionmanager)
add_simple_test(qxmppbitsofbinary)
add_simple_test(qxmppblockingmanager TestClient.h)
add_simple_test(qxmppcallinvitemanager)
add_simple_test(qxmppcarbonmanager)
add_simple_test(qxmppclient TestClient.h)
if(Qt${QT_VERSION_MAJOR}Gui_FOUND)
    target_link_libraries(tst_qxmppclient Qt::Gui)
endif()
add_simple_test(qxmppdataform)
add_simple_test(qxmppdiscoverymanager TestClient.h)
add_simple_test(qxmppentitytimemanager TestClient.h)
add_simple_test(qxmppexternalservicediscoverymanager TestClient.h)
add_simple_test(qxmppiceconnection)
add_simple_test(qxmppiq)
add_simple_test(qxmppjingledata)
add_simple_test(qxmppjinglemessageinitiationmanager)
add_simple_test(qxmppmammanager TestClient.h)
add_simple_test(qxmppmessage)
add_simple_test(qxmppmessagereaction)
add_simple_test(qxmppmessagereceiptmanager)
add_simple_test(qxmppmixinvitation)
add_simple_test(qxmppmixiq)
add_simple_test(qxmppmixitems)
add_simple_test(qxmppmixmanager TestClient.h)
add_simple_test(qxmppmovedmanager TestClient.h)
add_simple_test(qxmppmuc TestClient.h)
add_simple_test(qxmpppresence)
add_simple_test(qxmpppubsub)
add_simple_test(qxmpppubsubevent)
add_simple_test(qxmpppubsubforms)
add_simple_test(qxmpppubsubiq)
add_simple_test(qxmpppubsubmanager TestClient.h)
add_simple_test(qxmppregistrationmanager TestClient.h)
add_simple_test(qxmppresultset)
add_simple_test(qxmpprostermanager TestClient.h)
add_simple_test(qxmppsceenvelope)
add_simple_test(qxmppserver)
add_simple_test(qxmppsocks)
add_simple_test(qxmppstanza)
add_simple_test(qxmppstream)
add_simple_test(qxmppstreamfeatures)
add_simple_test(qxmppstunmessage)
add_simple_test(qxmpptrustmanager)
add_simple_test(qxmpptrustmessages)
add_simple_test(qxmppuri)
add_simple_test(qxmppuserlocationmanager TestClient.h)
add_simple_test(qxmppusertunemanager TestClient.h)
add_simple_test(qxmppvcardmanager TestClient.h)
add_simple_test(qxmppversionmanager TestClient.h)

if(WITH_QCA)
    add_simple_test(qxmppfileencryption)
endif()

if(WITH_GSTREAMER)
    add_simple_test(qxmppcallmanager)
endif()

if(BUILD_OMEMO)
    if(BUILD_INTERNAL_TESTS)
        add_simple_test(qxmppomemodata)
    endif()
    add_simple_test(qxmppomemomemorystorage)

    add_simple_test(qxmppomemomanager)
    target_link_libraries(tst_qxmppomemomanager PkgConfig::OmemoC qca-qt${QT_VERSION_MAJOR})
endif()

if(BUILD_INTERNAL_TESTS)
    add_simple_test(qxmppsasl)
endif()

add_subdirectory(qxmpptransfermanager)
add_subdirectory(qxmpputils)
add_subdirectory(qxmpphttpuploadmanager)

=== debian/changelog ===
qxmpp (1.13.0-1) unstable; urgency=medium

  * Team upload.

  [ Aurélien COUDERC ]
  * New upstream release (1.13.0).
  * Update build-deps and deps with the info from cmake.
  * Drop Rules-Requires-Root: no, not needed anymore since trixie.
  * Bump Standards-Version to 4.7.3, no change required.

 -- Aurélien COUDERC <coucouf@debian.org>  Sun, 11 Jan 2026 16:19:47 +0100

qxmpp (1.12.0-1) unstable; urgency=medium

  * Team upload.

  [ Aurélien COUDERC ]
  * New upstream release (1.12.0).
  * Update build-deps and deps with the info from cmake.
  * Bump library sonames to libqxmppqt6-7 and libqxmppomemoqt6-7.
  * Review copyright information.

 -- Aurélien COUDERC <coucouf@debian.org>  Sat, 06 Dec 2025 00:11:32 +0100

=== debian/control ===
Source: qxmpp
Section: libs
Priority: optional
Maintainer: Debian XMPP Maintainers <pkg-xmpp-devel@lists.alioth.debian.org>
Uploaders: Jeremy Lainé <jeremy.laine@m4x.org>,
           Boris Pek <tehnick@debian.org>,
Build-Depends: debhelper-compat (= 13),
               dpkg-dev (>= 1.22.5),
               cmake (>= 3.16~),
               doxygen,
               graphviz,
               libglib2.0-dev,
               libgstreamer1.0-dev,
               libomemo-c-dev,
               libprotobuf-c-dev,
               libqca-qt6-dev,
               pkgconf,
               qt6-5compat-dev,
               qt6-base-dev,
Standards-Version: 4.7.3
Homepage: https://invent.kde.org/libraries/qxmpp
Vcs-Git: https://salsa.debian.org/xmpp-team/qxmpp.git
Vcs-Browser: https://salsa.debian.org/xmpp-team/qxmpp

Package: libqxmppqt6-7
Architecture: any
Depends: gstreamer1.0-plugins-base,
         gstreamer1.0-plugins-good,
         gstreamer1.0-plugins-ugly,
         ${misc:Depends},
         ${shlibs:Depends},
Multi-Arch: same
Description: QXmpp library for XMPP client and server applications
 QXmpp is a cross-platform C++ XMPP library built upon Qt. It strives to be
 as easy to use as possible.
 .
 This package contains the shared library.

Package: libqxmppomemoqt6-7
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Multi-Arch: same
Description: QXmppOmemo library for XMPP client and server applications
 QXmpp is a cross-platform C++ XMPP library built upon Qt. It strives to be
 as easy to use as possible.
 .
 This package contains the OMEMO shared library.

Package: libqxmppqt6-dev
Section: libdevel
Architecture: any
Depends: libgstreamer1.0-dev,
         libqxmppomemoqt6-7 (= ${binary:Version}),
         libqxmppqt6-7 (= ${binary:Version}),
         qt6-base-dev,
         ${misc:Depends},
Breaks: libqxmpp-dev (<< 1.5.5-0.1~exp1~),
Replaces: libqxmpp-dev (<< 1.5.5-0.1~exp1~),
Suggests: libqxmpp-doc,
Multi-Arch: same
Description: Development files for the QXmpp library
 QXmpp is a cross-platform C++ XMPP library built upon Qt. It strives to be
 as easy to use as possible.
 .
 This package contains the development headers and libraries.

Package: libqxmpp-doc
Section: doc
Architecture: all
Depends: lynx | www-browser,
         ${misc:Depends},
Suggests: libqxmppqt6-dev,
Description: Documentation for the QXmpp library
 QXmpp is a cross-platform C++ XMPP library built upon Qt. It strives to be
 as easy to use as possible.
 .
 This package contains the HTML documentation.

## qxmpp 1.14.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,14 +3,19 @@
 # SPDX-License-Identifier: CC0-1.0
 
 cmake_minimum_required(VERSION 3.16)
-project(qxmpp VERSION 1.13.0)
+project(qxmpp VERSION 1.14.1)
 
-set(SO_VERSION 7)
+set(SO_VERSION 8)
 
-# C++ standard settings:
+# C/C++ settings
 set(CMAKE_CXX_STANDARD 20)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_CXX_EXTENSIONS OFF)
+
+set(CMAKE_C_VISIBILITY_PRESET hidden)
+set(CMAKE_CXX_VISIBILITY_PRESET hidden)
+set(CMAKE_VISIBILITY_INLINES_HIDDEN 1)
+set(CMAKE_POSITION_INDEPENDENT_CODE ON)
 
 set(CMAKE_AUTOMOC ON)
 set(CMAKE_AUTORCC ON)
@@ -38,7 +43,6 @@
 option(BUILD_WITH_QT6 "Force build with Qt 6")
 option(BUILD_SHARED "Build shared library" ON)
 option(BUILD_TESTS "Build tests." ON)
-option(BUILD_INTERNAL_TESTS "Build internal tests." OFF)
 option(BUILD_DOCUMENTATION "Build API documentation." OFF)
 option(BUILD_EXAMPLES "Build examples." ON)
 option(BUILD_OMEMO "Build the OMEMO module" OFF)
@@ -83,7 +87,6 @@
 
 if(WITH_GSTREAMER)
     pkg_check_modules(GStreamer REQUIRED IMPORTED_TARGET gstreamer-1.0>=1.20)
-    pkg_check_modules(GStreamerBase REQUIRED IMPORTED_TARGET gstreamer-base-1.0)
 endif()
 
 add_subdirectory(src)

=== examples/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2017 Niels Ole Salscheider <niels_ole@salscheider-online.de>
#
# SPDX-License-Identifier: CC0-1.0

find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Gui)

macro(add_simple_example EXAMPLE_NAME)
    add_executable(${EXAMPLE_NAME} example_${EXAMPLE_NAME}/example_${EXAMPLE_NAME}.cpp)
    target_link_libraries(${EXAMPLE_NAME} ${QXMPP_TARGET})
endmacro()

add_simple_example(0_connected)
add_simple_example(1_echoClient)
add_simple_example(2_rosterHandling)
add_simple_example(3_transferHandling)
add_simple_example(7_archiveHandling)
add_simple_example(8_server)

# VCard
add_simple_example(9_vCard)
target_link_libraries(9_vCard Qt${QT_VERSION_MAJOR}::Gui)

# AV Calls
if(WITH_GSTREAMER)
    add_executable(audio_call audio_call/AudioCall.cpp)
    target_link_libraries(audio_call PUBLIC ${QXMPP_TARGET} PkgConfig::GStreamer)
endif()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -86,11 +86,13 @@
     base/QXmppStreamError.h
     base/QXmppStreamFeatures.h
     base/QXmppStun.h
+    base/QXmppStunServer.h
     base/QXmppTask.h
     base/QXmppThumbnail.h
     base/QXmppTrustMessageElement.h
     base/QXmppTrustMessageKeyOwner.h
     base/QXmppTrustMessages.h
+    base/QXmppTurnServer.h
     base/QXmppUserTuneItem.h
     base/QXmppUtils.h
     base/QXmppUtils_p.h
@@ -307,68 +309,69 @@
     server/QXmppServerPlugin.cpp
 )
 
+#
+# internal static library with all symbols visible
+#
+
+add_library(${QXMPP_TARGET}_internal OBJECT ${SOURCE_FILES})
+target_include_directories(${QXMPP_TARGET}_internal
+    PUBLIC
+    ${CMAKE_CURRENT_SOURCE_DIR}/base ${CMAKE_CURRENT_SOURCE_DIR}/client ${CMAKE_CURRENT_SOURCE_DIR}/server
+    ${CMAKE_CURRENT_BINARY_DIR}
+)
+target_link_libraries(${QXMPP_TARGET}_internal
+    PUBLIC Qt${QT_VERSION_MAJOR}::Core Qt${QT_VERSION_MAJOR}::Network Qt${QT_VERSION_MAJOR}::Xml
+)
+target_compile_definitions(${QXMPP_TARGET}_internal PRIVATE ${QXMPP_TARGET}_EXPORTS)
+
+if(WITH_GSTREAMER)
+    set(INSTALL_HEADER_FILES
+        ${INSTALL_HEADER_FILES} client/QXmppCall.h client/QXmppCallManager.h client/QXmppCallStream.h)
+    target_sources(${QXMPP_TARGET}_internal
+        PRIVATE client/GstWrapper.cpp client/QXmppCall.cpp client/QXmppCallManager.cpp client/QXmppCallStream.cpp)
+    target_link_libraries(${QXMPP_TARGET}_internal PUBLIC PkgConfig::GStreamer)
+endif()
+
+if(BUILD_OMEMO)
+    # required to be used in QXmppMessage
+    target_sources(${QXMPP_TARGET}_internal PRIVATE base/QXmppOmemoDataBase.cpp)
+endif()
+
+if(WITH_QCA)
+    target_sources(${QXMPP_TARGET}_internal
+        PRIVATE client/QXmppEncryptedFileSharingProvider.cpp client/QXmppFileEncryption.cpp client/QcaInitializer.cpp)
+    set(INSTALL_HEADER_FILES ${INSTALL_HEADER_FILES} client/QXmppEncryptedFileSharingProvider.h)
+    target_link_libraries(${QXMPP_TARGET}_internal PUBLIC qca-qt${QT_VERSION_MAJOR})
+endif()
+
+#
+# public shared/static library, only with exported symbols
+#
+
 if(BUILD_SHARED)
-    add_library(${QXMPP_TARGET} SHARED ${SOURCE_FILES})
+    add_library(${QXMPP_TARGET} SHARED)
 else()
-    add_library(${QXMPP_TARGET} STATIC ${SOURCE_FILES})
-endif()
-
+    add_library(${QXMPP_TARGET} STATIC)
+endif()
+
+target_sources(${QXMPP_TARGET} PRIVATE $<TARGET_OBJECTS:${QXMPP_TARGET}_internal>)
 set_target_properties(${QXMPP_TARGET} PROPERTIES
     VERSION ${PROJECT_VERSION}
     SOVERSION ${SO_VERSION}
     EXPORT_NAME QXmpp
 )
-
+target_link_libraries(${QXMPP_TARGET}
+    PUBLIC Qt${QT_VERSION_MAJOR}::Core Qt${QT_VERSION_MAJOR}::Network Qt${QT_VERSION_MAJOR}::Xml
+    PRIVATE ${QXMPP_TARGET}_internal
+)
 target_include_directories(${QXMPP_TARGET}
     PUBLIC
     $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/base>
     $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/client>
     $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/server>
+    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
     $<INSTALL_INTERFACE:include/${QXMPP_TARGET}>
-    PRIVATE
-    ${CMAKE_CURRENT_BINARY_DIR}
-)
-
-target_link_libraries(${QXMPP_TARGET}
-    PUBLIC
-    Qt${QT_VERSION_MAJOR}::Core
-    Qt${QT_VERSION_MAJOR}::Network
-    Qt${QT_VERSION_MAJOR}::Xml
-)
-
-if(WITH_GSTREAMER)
-    set(INSTALL_HEADER_FILES
-        ${INSTALL_HEADER_FILES}
-        client/QXmppCall.h
-        client/QXmppCallManager.h
-        client/QXmppCallStream.h
-    )
-
-    target_sources(${QXMPP_TARGET}
-        PRIVATE
-        client/GstWrapper.cpp
-        client/QXmppCall.cpp
-        client/QXmppCallManager.cpp
-        client/QXmppCallStream.cpp
-    )
-
-    target_link_libraries(${QXMPP_TARGET}
-        PRIVATE
-        PkgConfig::GStreamer
-        PkgConfig::GStreamerBase
-    )
-endif()
-
-if(BUILD_OMEMO)
-    # required to be used in QXmppMessage
-    target_sources(${QXMPP_TARGET} PRIVATE base/QXmppOmemoDataBase.cpp)
-endif()
-
-if(WITH_QCA)
-    target_sources(${QXMPP_TARGET} PRIVATE client/QXmppEncryptedFileSharingProvider.cpp client/QXmppFileEncryption.cpp client/QcaInitializer.cpp)
-    set(INSTALL_HEADER_FILES ${INSTALL_HEADER_FILES} client/QXmppEncryptedFileSharingProvider.h)
-    target_link_libraries(${QXMPP_TARGET} PRIVATE qca-qt${QT_VERSION_MAJOR})
-endif()
+)
 
 # qxmpp_export.h generation
 if(BUILD_SHARED)
@@ -386,35 +389,3 @@
 
 generate_export_header(${QXMPP_TARGET}
     BASE_NAME qxmpp
-    CUSTOM_CONTENT_FROM_VARIABLE QXMPP_CUSTOM_EXPORT_CONTENT
-)
-
-install(
-    TARGETS ${QXMPP_TARGET}
-    EXPORT QXmppTarget
-    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
-    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
-    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
-)
-
-install(
-    EXPORT QXmppTarget
-    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${QXMPP_TARGET}"
-    FILE QXmpp.cmake
-    NAMESPACE QXmpp::
-    COMPONENT Devel
-)
-
-export(
-    TARGETS ${QXMPP_TARGET}
-    FILE QXmpp.cmake
-)
-
-install(
-    FILES ${INSTALL_HEADER_FILES} ${CMAKE_CURRENT_BINARY_DIR}/qxmpp_export.h
-    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/${QXMPP_TARGET}"
-)
-
-# submodules
-if(BUILD_OMEMO)
-    add_subdirectory(omemo)

=== tests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2017 Niels Ole Salscheider <niels_ole@salscheider-online.de>
#
# SPDX-License-Identifier: CC0-1.0

include_directories(.)

find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Test)

# optional QtGui support (for testing header-only usage)
find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Gui QUIET)

add_library(testutils OBJECT util.h TestClient.h)
target_link_libraries(testutils PUBLIC Qt${QT_VERSION_MAJOR}::Test ${QXMPP_TARGET}_internal)

macro(add_simple_test TEST_NAME)
    add_executable(tst_${TEST_NAME} ${TEST_NAME}/tst_${TEST_NAME}.cpp $<TARGET_OBJECTS:testutils> ${ARGN})
    add_test(tst_${TEST_NAME} tst_${TEST_NAME})
    target_link_libraries(tst_${TEST_NAME} Qt${QT_VERSION_MAJOR}::Test ${QXMPP_TARGET}_internal)
    target_compile_definitions(tst_${TEST_NAME} PRIVATE QXMPP_STATIC_DEFINE)

    if(${TEST_NAME} MATCHES "^qxmppomemo")
        target_link_libraries(tst_${TEST_NAME} ${QXMPPOMEMO_TARGET}_internal)
        target_compile_definitions(tst_${TEST_NAME} PRIVATE QXMPPOMEMO_STATIC_DEFINE)
    endif()
endmacro()

add_simple_test(qxmppaccountmigrationmanager)
add_simple_test(qxmppattentionmanager)
add_simple_test(qxmppbitsofbinary)
add_simple_test(qxmppblockingmanager)
add_simple_test(qxmppcallinvitemanager)
add_simple_test(qxmppcarbonmanager)
add_simple_test(qxmppclient)
if(Qt${QT_VERSION_MAJOR}Gui_FOUND)
    target_link_libraries(tst_qxmppclient Qt::Gui)
endif()
add_simple_test(qxmppdataform)
add_simple_test(qxmppdiscoverymanager)
add_simple_test(qxmppentitytimemanager)
add_simple_test(qxmppexternalservicediscoverymanager)
add_simple_test(qxmpphttpuploadmanager qxmpphttpuploadmanager/tst_qxmpphttpuploadmanager.qrc)
add_simple_test(qxmppiceconnection)
add_simple_test(qxmppiq)
add_simple_test(qxmppjingledata)
add_simple_test(qxmppjinglemessageinitiationmanager)
add_simple_test(qxmppmammanager)
add_simple_test(qxmppmessage)
add_simple_test(qxmppmessagereaction)
add_simple_test(qxmppmessagereceiptmanager)
add_simple_test(qxmppmixinvitation)
add_simple_test(qxmppmixiq)
add_simple_test(qxmppmixitems)
add_simple_test(qxmppmixmanager)
add_simple_test(qxmppmovedmanager)
add_simple_test(qxmppmuc)
add_simple_test(qxmpppresence)
add_simple_test(qxmpppubsub)
add_simple_test(qxmpppubsubevent)
add_simple_test(qxmpppubsubforms)
add_simple_test(qxmpppubsubiq)
add_simple_test(qxmpppubsubmanager)
add_simple_test(qxmppregistrationmanager)
add_simple_test(qxmppresultset)
add_simple_test(qxmpprostermanager)
add_simple_test(qxmppsasl)
add_simple_test(qxmppsceenvelope)
add_simple_test(qxmppserver)
add_simple_test(qxmppsocks)
add_simple_test(qxmppstanza)
add_simple_test(qxmppstream)
add_simple_test(qxmppstreamfeatures)
add_simple_test(qxmppstunmessage)
add_simple_test(qxmpptransfermanager qxmpptransfermanager/tst_qxmpptransfermanager.qrc)
add_simple_test(qxmpptrustmanager)
add_simple_test(qxmpptrustmessages)
add_simple_test(qxmppuri)
add_simple_test(qxmppuserlocationmanager)
add_simple_test(qxmppusertunemanager)
add_simple_test(qxmpputils qxmpputils/tst_qxmpputils.qrc)
add_simple_test(qxmppvcardmanager)
add_simple_test(qxmppversionmanager)

if(WITH_QCA)
    add_simple_test(qxmppfileencryption)
endif()

if(WITH_GSTREAMER)
    add_simple_test(qxmppcallmanager)
endif()

if(BUILD_OMEMO)
    add_simple_test(qxmppomemodata)
    add_simple_test(qxmppomemomemorystorage)
    add_simple_test(qxmppomemomanager)
endif()

=== src/omemo/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 Linus Jahn <lnj@kaidan.im>
#
# SPDX-License-Identifier: CC0-1.0

include(CMakePackageConfigHelpers)

set(OMEMO_CMAKE_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/${QXMPPOMEMO_TARGET}")
set(OMEMO_HEADER_DIR "${CMAKE_INSTALL_FULL_INCLUDEDIR}/${QXMPP_TARGET}/Omemo")
set(OMEMO_INSTALL_HEADER_FILES
    QXmppOmemoManager.h
    QXmppOmemoMemoryStorage.h
    QXmppOmemoStorage.h
)
set(OMEMO_SOURCE_FILES
    OmemoCryptoProvider.cpp
    QXmppOmemoData.cpp
    QXmppOmemoManager.cpp
    QXmppOmemoManager_p.cpp
    QXmppOmemoMemoryStorage.cpp
    QXmppOmemoStorage.cpp
)

# internal object library, all symbols
add_library(${QXMPPOMEMO_TARGET}_internal OBJECT ${OMEMO_SOURCE_FILES})
target_link_libraries(${QXMPPOMEMO_TARGET}_internal
    PUBLIC ${QXMPP_TARGET}_internal PkgConfig::OmemoC qca-qt${QT_VERSION_MAJOR}
)
target_include_directories(${QXMPPOMEMO_TARGET}_internal PUBLIC ${CMAKE_CURRENT_LIST_DIR} ${CMAKE_CURRENT_BINARY_DIR})
target_compile_definitions(${QXMPPOMEMO_TARGET}_internal PRIVATE ${QXMPPOMEMO_TARGET}_EXPORTS)

# public shared/static library, only exported symbols
if(BUILD_SHARED)
    add_library(${QXMPPOMEMO_TARGET} SHARED)
else()
    add_library(${QXMPPOMEMO_TARGET} STATIC)
endif()
target_sources(${QXMPPOMEMO_TARGET} PRIVATE $<TARGET_OBJECTS:${QXMPPOMEMO_TARGET}_internal>)

target_link_libraries(${QXMPPOMEMO_TARGET}
    PUBLIC ${QXMPP_TARGET}
    PRIVATE ${QXMPPOMEMO_TARGET}_internal
)
target_include_directories(${QXMPPOMEMO_TARGET}
    PUBLIC
    $<INSTALL_INTERFACE:include/${QXMPP_TARGET}/Omemo>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
)

generate_export_header(${QXMPPOMEMO_TARGET} BASE_NAME qxmppomemo)

install(
    FILES ${OMEMO_INSTALL_HEADER_FILES} ${CMAKE_CURRENT_BINARY_DIR}/qxmppomemo_export.h
    DESTINATION ${OMEMO_HEADER_DIR}
)

set_target_properties(${QXMPPOMEMO_TARGET} PROPERTIES
    VERSION ${PROJECT_VERSION}
    SOVERSION ${SO_VERSION}
    EXPORT_NAME Omemo
)

install(
    TARGETS ${QXMPPOMEMO_TARGET}
    EXPORT QXmppOmemoTargets
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(
    EXPORT QXmppOmemoTargets
    DESTINATION ${OMEMO_CMAKE_DIR}
    FILE QXmppOmemo.cmake
    NAMESPACE QXmpp::
    COMPONENT Devel
)

export(
    TARGETS ${QXMPPOMEMO_TARGET}
    FILE QXmppOmemo.cmake
)

configure_package_config_file(
    QXmppOmemoConfig.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/${QXMPPOMEMO_TARGET}Config.cmake
    INSTALL_DESTINATION ${OMEMO_CMAKE_DIR}
)

write_basic_package_version_file(
    ${CMAKE_CURRENT_BINARY_DIR}/${QXMPPOMEMO_TARGET}ConfigVersion.cmake
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY SameMajorVersion
)

install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/${QXMPPOMEMO_TARGET}Config.cmake
          ${CMAKE_CURRENT_BINARY_DIR}/${QXMPPOMEMO_TARGET}ConfigVersion.cmake
    DESTINATION ${OMEMO_CMAKE_DIR}
    COMPONENT Devel
)

=== debian/changelog ===
qxmpp (1.14.1-1) unstable; urgency=medium

  * Team upload.

  [ Aurélien COUDERC ]
  * New upstream release (1.14.1).
  * Drop Priority: optional, not needed anymore since dpkg 1.22.13.
  * Bump library sonames to libqxmppqt6-8 and libqxmppomemoqt6-8.
  * Refresh copyright information.

 -- Aurélien COUDERC <coucouf@debian.org>  Tue, 10 Feb 2026 18:26:29 +0100

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: qxmpp
 Section: libs
-Priority: optional
 Maintainer: Debian XMPP Maintainers <pkg-xmpp-devel@lists.alioth.debian.org>
 Uploaders: Jeremy Lainé <jeremy.laine@m4x.org>,
            Boris Pek <tehnick@debian.org>,
@@ -22,7 +21,7 @@
 Vcs-Git: https://salsa.debian.org/xmpp-team/qxmpp.git
 Vcs-Browser: https://salsa.debian.org/xmpp-team/qxmpp
 
-Package: libqxmppqt6-7
+Package: libqxmppqt6-8
 Architecture: any
 Depends: gstreamer1.0-plugins-base,
          gstreamer1.0-plugins-good,
@@ -36,7 +35,7 @@
  .
  This package contains the shared library.
 
-Package: libqxmppomemoqt6-7
+Package: libqxmppomemoqt6-8
 Architecture: any
 Depends: ${misc:Depends},
          ${shlibs:Depends},
@@ -51,8 +50,8 @@
 Section: libdevel
 Architecture: any
 Depends: libgstreamer1.0-dev,
-         libqxmppomemoqt6-7 (= ${binary:Version}),
-         libqxmppqt6-7 (= ${binary:Version}),
+         libqxmppomemoqt6-8 (= ${binary:Version}),
+         libqxmppqt6-8 (= ${binary:Version}),
          qt6-base-dev,
          ${misc:Depends},
 Breaks: libqxmpp-dev (<< 1.5.5-0.1~exp1~),
